{"openapi":"3.0.4","info":{"title":"Upsert transactions","description":"Create or update transactions in the transaction portfolio. A transaction will be updated\r\nif it already exists and created if it does not.\n\nThe maximum number of transactions that this method can upsert per request is 10,000.","version":"0.0.1"},"servers":[{"url":"https://fbn-prd.lusid.com/api"}],"paths":{"/api/transactionportfolios/{scope}/{code}/transactions":{"post":{"tags":["Transaction Portfolios"],"summary":"Upsert transactions","description":"Create or update transactions in the transaction portfolio. A transaction will be updated\r\nif it already exists and created if it does not.\n\nThe maximum number of transactions that this method can upsert per request is 10,000.","operationId":"UpsertTransactions","parameters":[{"name":"scope","in":"path","description":"The scope of the transaction portfolio.","required":true,"schema":{"maxLength":64,"minLength":1,"pattern":"^[a-zA-Z0-9\\-_]+$","type":"string"}},{"name":"code","in":"path","description":"The code of the transaction portfolio. Together with the scope this uniquely identifies\r\n            the transaction portfolio.","required":true,"schema":{"maxLength":64,"minLength":1,"pattern":"^[a-zA-Z0-9\\-_]+$","type":"string"}},{"name":"preserveProperties","in":"query","description":"If set to false, the entire property set will be overwritten by the provided properties. If not specified or set to true, only the properties provided will be updated.","schema":{"type":"boolean","default":true},"x-nullable":true},{"name":"dataModelScope","in":"query","description":"The optional scope of a Custom Data Model to use","schema":{"maxLength":64,"minLength":1,"pattern":"^[a-zA-Z0-9\\-_]+$","type":"string"}},{"name":"dataModelCode","in":"query","description":"The optional code of a Custom Data Model to use","schema":{"maxLength":64,"minLength":1,"pattern":"^[a-zA-Z0-9\\-_]+$","type":"string"}}],"requestBody":{"description":"A list of transactions to be created or updated.","content":{"application/json-patch+json":{"schema":{"type":"array","items":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/TransactionRequest"}},"example":[{"transactionId":"TransactionId-111111","type":"StockIn","instrumentIdentifiers":{"Instrument/default/Figi":"BBG000C6K6G9","Instrument/default/Isin":"GB00BH4HKS39"},"transactionDate":"2018-03-05T00:00:00.0000000+00:00","settlementDate":"2018-03-08T00:00:00.0000000+00:00","units":1000,"transactionPrice":{"price":123,"type":"Price"},"totalConsideration":{"amount":123000,"currency":"GBP"},"transactionCurrency":"GBP","properties":{"Transaction/Algo/Name":{"key":"Transaction/Algo/Name","value":{"labelValue":"Algo1"}}},"counterpartyId":"CounterpartyId-118263","source":"","otcConfirmation":{"counterpartyAgreementId":{"scope":"someScope","code":"someCode"}},"orderId":{"scope":"someScope","code":"ORD001"},"allocationId":{"scope":"someScope","code":"ALLOC001"}}]},"application/json":{"schema":{"type":"array","items":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/TransactionRequest"}},"example":[{"transactionId":"TransactionId-111111","type":"StockIn","instrumentIdentifiers":{"Instrument/default/Figi":"BBG000C6K6G9","Instrument/default/Isin":"GB00BH4HKS39"},"transactionDate":"2018-03-05T00:00:00.0000000+00:00","settlementDate":"2018-03-08T00:00:00.0000000+00:00","units":1000,"transactionPrice":{"price":123,"type":"Price"},"totalConsideration":{"amount":123000,"currency":"GBP"},"transactionCurrency":"GBP","properties":{"Transaction/Algo/Name":{"key":"Transaction/Algo/Name","value":{"labelValue":"Algo1"}}},"counterpartyId":"CounterpartyId-118263","source":"","otcConfirmation":{"counterpartyAgreementId":{"scope":"someScope","code":"someCode"}},"orderId":{"scope":"someScope","code":"ORD001"},"allocationId":{"scope":"someScope","code":"ALLOC001"}}]},"text/json":{"schema":{"type":"array","items":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/TransactionRequest"}},"example":[{"transactionId":"TransactionId-111111","type":"StockIn","instrumentIdentifiers":{"Instrument/default/Figi":"BBG000C6K6G9","Instrument/default/Isin":"GB00BH4HKS39"},"transactionDate":"2018-03-05T00:00:00.0000000+00:00","settlementDate":"2018-03-08T00:00:00.0000000+00:00","units":1000,"transactionPrice":{"price":123,"type":"Price"},"totalConsideration":{"amount":123000,"currency":"GBP"},"transactionCurrency":"GBP","properties":{"Transaction/Algo/Name":{"key":"Transaction/Algo/Name","value":{"labelValue":"Algo1"}}},"counterpartyId":"CounterpartyId-118263","source":"","otcConfirmation":{"counterpartyAgreementId":{"scope":"someScope","code":"someCode"}},"orderId":{"scope":"someScope","code":"ORD001"},"allocationId":{"scope":"someScope","code":"ALLOC001"}}]},"application/*+json":{"schema":{"type":"array","items":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/TransactionRequest"}},"example":[{"transactionId":"TransactionId-111111","type":"StockIn","instrumentIdentifiers":{"Instrument/default/Figi":"BBG000C6K6G9","Instrument/default/Isin":"GB00BH4HKS39"},"transactionDate":"2018-03-05T00:00:00.0000000+00:00","settlementDate":"2018-03-08T00:00:00.0000000+00:00","units":1000,"transactionPrice":{"price":123,"type":"Price"},"totalConsideration":{"amount":123000,"currency":"GBP"},"transactionCurrency":"GBP","properties":{"Transaction/Algo/Name":{"key":"Transaction/Algo/Name","value":{"labelValue":"Algo1"}}},"counterpartyId":"CounterpartyId-118263","source":"","otcConfirmation":{"counterpartyAgreementId":{"scope":"someScope","code":"someCode"}},"orderId":{"scope":"someScope","code":"ORD001"},"allocationId":{"scope":"someScope","code":"ALLOC001"}}]}},"required":true},"responses":{"200":{"description":"The version of the transaction portfolio that contains the newly updated or inserted transactions","content":{"application/json":{"schema":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/UpsertPortfolioTransactionsResponse"},"example":{"version":{"effectiveFrom":"2018-03-05T11:32:15.0000000+00:00","asAtDate":"2022-03-05T10:09:01.0000000+00:00"},"metadata":{"warnings":[{"type":"TransactionTypesNotFound","description":"No transaction types could be found for the listed transactions","identifierType":"TransactionId","identifiers":["Transaction-001","Transaction-123"]}]}}},"text/plain":{"schema":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/UpsertPortfolioTransactionsResponse"},"example":{"version":{"effectiveFrom":"2018-03-05T11:32:15.0000000+00:00","asAtDate":"2022-03-05T10:09:01.0000000+00:00"},"metadata":{"warnings":[{"type":"TransactionTypesNotFound","description":"No transaction types could be found for the listed transactions","identifierType":"TransactionId","identifiers":["Transaction-001","Transaction-123"]}]}}},"text/json":{"schema":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/UpsertPortfolioTransactionsResponse"},"example":{"version":{"effectiveFrom":"2018-03-05T11:32:15.0000000+00:00","asAtDate":"2022-03-05T10:09:01.0000000+00:00"},"metadata":{"warnings":[{"type":"TransactionTypesNotFound","description":"No transaction types could be found for the listed transactions","identifierType":"TransactionId","identifiers":["Transaction-001","Transaction-123"]}]}}}}},"400":{"description":"The details of the input related failure","content":{"application/json":{"schema":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/LusidValidationProblemDetails"}},"text/plain":{"schema":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/LusidValidationProblemDetails"}},"text/json":{"schema":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/LusidValidationProblemDetails"}}}},"default":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"/docs/api/lusid/schemas.json#/components/schemas/LusidProblemDetails"}}}}},"security":[{"BearerAuth":[]}],"x-fbn-apistatus":"Stable"}}},"components":{"securitySchemes":{"BearerAuth":{"type":"http","scheme":"bearer"}}}}